let time = null;
const _Http = getApp().globalData.http;
const MD5 = require('../../../../utils/md5'),
    deletMark = require("../../../../utils/Check");
Page({
    /**
     * 页面的初始数据
     */
    data: {
        site: getApp().globalData.site,
        attinfos: [],
        fromList1: [{
            label: "姓名",
            error: false,
            errMsg: "",
            type: "text",
            value: "",
            placeholder: "请填写",
            valueName: "name", //绑定的字段名称
            required: true, //必填
        }, {
            label: "邮箱",
            error: false,
            errMsg: "",
            type: "text",
            value: "",
            placeholder: "请填写",
            valueName: "email", //绑定的字段名称
            required: true //必填
        }],
        disabled: true, //禁用按钮
        show: false, //显示验证码输入框
        password: "", //验证码
        countDown: 0, //倒计时
        loading: false
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad(options) {
        const that = this;
        console.log(options.email)
        this.setData({
            attinfos: JSON.parse(options.attinfos),
            "fromList1[0].value": options.name,
            "fromList1[1].value": options.email == "undefined" ? "" : options.email,
            "copyPhonenumber": options.phonenumber
        });
        if (!['美大'].includes(this.data.site)) { //美大禁用修改手机号
            this.data.fromList1.push({
                label: "手机号",
                error: false,
                errMsg: "",
                type: "text",
                value: options.phonenumber,
                placeholder: "请填写",
                valueName: "phonenumber", //绑定的字段名称
                required: true, //必填
                callback: function ({
                    value
                }) {
                    that.setData({
                        show: (value != that.data.copyPhonenumber) ? true : false,
                        newPhone: value
                    })
                },
            })
            this.setData({
                fromList1:this.data.fromList1
            })
        }
    },
    /* from1监听 */
    form1CompletedOrNot({
        detail
    }) {
        this.setData({
            disabled: !detail
        })
        if (this.data.show) this.setData({
            disabled: this.data.password.length == 6
        })
    },
    /* 开始倒计时 */
    startCountDown() {
        let countDown = this.data.countDown;
        if (countDown != 0) return wx.showToast({
            title: '已发送验证码,请勿重新发送',
            icon: "none"
        });
        if (!deletMark.CheckPhoneNumber(this.data.newPhone.trim() - 0)) return;
        _Http.basic({
            "classname": "common.usercenter.usercenter",
            "method": "updateUserMsg_getPassWord",
            "content": {
                "phonenumber": this.data.newPhone.trim()
            }
        }).then(res => {
            console.log(res)
            wx.showToast({
                title: res.msg,
                icon: "none"
            })
            if (res.code != 1) return;
            this.setData({
                countDown: 30
            })
            time = setInterval(() => {
                if (this.data.countDown == '0') return clearInterval(time);
                this.setData({
                    countDown: this.data.countDown - 1
                })
            }, 1000);
        })
    },
    /* 提交 */
    submit() {
        if (this.data.disabled || this.data.loading) return;
        let data = this.selectComponent("#form1").getData().returnData;
        if (!['美大'].includes(this.data.site) && !deletMark.CheckPhoneNumber(data.phonenumber.trim() - 0)) return;
        if (!deletMark.CheckEmail(data.email.trim())) return;
        if (this.data.show && this.data.password.length == 0) return wx.showToast({
            title: '请输入短信验证码',
            icon: "none"
        });
        this.setData({
            loading: true
        });
        _Http.basic({
            "classname": "common.usercenter.usercenter",
            "method": "updateUserMsg",
            "content": {
                "name": data.name,
                "phonenumber": !['美大'].includes(this.data.site) ? data.phonenumber : this.data.copyPhonenumber,
                "email": data.email,
                "password": MD5.hexMD5(this.data.password.trim())
            }
        }).then(res => {
            this.setData({
                loading: false
            })
            if (res.code != 1) return wx.showToast({
                title: res.msg,
                icon: "none"
            });
            wx.showToast({
                title: '修改成功'
            });
            this.changeUserMsg();
            setTimeout(() => {
                wx.navigateBack({
                    delta: 0,
                })
            }, 300);
        })
    },
    changeUserMsg() {
        let pages = getCurrentPages();
        let prevPage = pages[pages.length - 2];
        prevPage.queryUserMsg();
    },
    changeUserImage({
        detail
    }) {
        _Http.basic({
            "classname": "system.attachment.Attachment",
            "method": "createFileLink",
            "content": {
                "ownertable": "sys_users",
                "ownerid": wx.getStorageSync('userMsg').userid,
                "usetype": "headportrait",
                "attachmentids": detail
            }
        }).then(async res => {
            if (res.msg != '成功') return wx.showToast({
                title: res.msg,
                icon: "none"
            })
            let linksids = this.data.attinfos.map(v => v.linksid);
            if (linksids.length) await _Http.basic({
                "classname": "system.attachment.Attachment",
                "method": "deleteFileLink",
                "content": {
                    "linksids": linksids
                }
            });
            this.setData({
                attinfos: res.data
            })
            this.changeUserMsg();
        })
    },
})